/*
 * Automatically generated by jrpcgen 0.93.0 on 02.03.01 10:02
 * jrpcgen is part of the "Remote Tea" ONC/RPC package for Java
 * See http://acplt.org/ks/remotetea.html for details
 */
package tests.org.acplt.oncrpc.jrpcgen;
import org.acplt.oncrpc.*;
import java.io.IOException;

import java.net.InetAddress;

/**
 * The class <code>demoClient</code> implements the client stub proxy
 * for the DEMO remote program. It provides method stubs
 * which, when called, in turn call the appropriate remote method (procedure).
 */
public class demoClient extends OncRpcClientStub {

    /**
     * Constructs a <code>demoClient</code> client stub proxy object
     * from which the DEMO remote program can be accessed.
     * @param host Internet address of host where to contact the remote program.
     * @param protocol {@link org.acplt.oncrpc.OncRpcProtocols Protocol} to be
     *   used for ONC/RPC calls.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public demoClient(InetAddress host, int protocol)
           throws OncRpcException, IOException {
        super(host, demo.DEMO, 2, 0, protocol);
    }

    /**
     * Constructs a <code>demoClient</code> client stub proxy object
     * from which the DEMO remote program can be accessed.
     * @param host Internet address of host where to contact the remote program.
     * @param port Port number at host where the remote program can be reached.
     * @param protocol {@link org.acplt.oncrpc.OncRpcProtocols Protocol} to be
     *   used for ONC/RPC calls.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public demoClient(InetAddress host, int port, int protocol)
           throws OncRpcException, IOException {
        super(host, demo.DEMO, 2, port, protocol);
    }

    /**
     * Constructs a <code>demoClient</code> client stub proxy object
     * from which the DEMO remote program can be accessed.
     * @param client ONC/RPC client connection object implementing a particular
     *   protocol.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public demoClient(OncRpcClient client)
           throws OncRpcException, IOException {
        super(client);
    }

    /**
     * Constructs a <code>demoClient</code> client stub proxy object
     * from which the DEMO remote program can be accessed.
     * @param host Internet address of host where to contact the remote program.
     * @param program Remote program number.
     * @param version Remote program version number.
     * @param protocol {@link org.acplt.oncrpc.OncRpcProtocols Protocol} to be
     *   used for ONC/RPC calls.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public demoClient(InetAddress host, int program, int version, int protocol)
           throws OncRpcException, IOException {
        super(host, program, version, 0, protocol);
    }

    /**
     * Constructs a <code>demoClient</code> client stub proxy object
     * from which the DEMO remote program can be accessed.
     * @param host Internet address of host where to contact the remote program.
     * @param program Remote program number.
     * @param version Remote program version number.
     * @param port Port number at host where the remote program can be reached.
     * @param protocol {@link org.acplt.oncrpc.OncRpcProtocols Protocol} to be
     *   used for ONC/RPC calls.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public demoClient(InetAddress host, int program, int version, int port, int protocol)
           throws OncRpcException, IOException {
        super(host, program, version, port, protocol);
    }

    /**
     * Call remote procedure NULL_1.
     * @param params Parameter(s) to the remote procedure call.
     * @return Result from remote procedure call.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public void NULL_1()
           throws OncRpcException, IOException {
        XdrVoid xparams = XdrVoid.XDR_VOID;
        XdrVoid xresult = XdrVoid.XDR_VOID;
        client.call(demo.NULL_1, xparams, xresult);
    }

    /**
     * Call remote procedure echo_1.
     * @param params Parameter(s) to the remote procedure call.
     * @return Result from remote procedure call.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public String echo_1(String params)
           throws OncRpcException, IOException {
        XdrString xparams = new XdrString(params);
        XdrString xresult = new XdrString();
        client.call(demo.echo_1, xparams, xresult);
        return xresult.stringValue();
    }

    /**
     * Call remote procedure concat_1.
     * @param params Parameter(s) to the remote procedure call.
     * @return Result from remote procedure call.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public String concat_1(STRINGVECTOR params)
           throws OncRpcException, IOException {
        XdrString xresult = new XdrString();
        client.call(demo.concat_1, params, xresult);
        return xresult.stringValue();
    }

    /**
     * Call remote procedure checkfoo_1.
     * @param params Parameter(s) to the remote procedure call.
     * @return Result from remote procedure call.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public boolean checkfoo_1(int params)
           throws OncRpcException, IOException {
        XdrInt xparams = new XdrInt(params);
        XdrBoolean xresult = new XdrBoolean();
        client.call(demo.checkfoo_1, xparams, xresult);
        return xresult.booleanValue();
    }

    /**
     * Call remote procedure foo_1.
     * @param params Parameter(s) to the remote procedure call.
     * @return Result from remote procedure call.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public int foo_1()
           throws OncRpcException, IOException {
        XdrVoid xparams = XdrVoid.XDR_VOID;
        XdrInt xresult = new XdrInt();
        client.call(demo.foo_1, xparams, xresult);
        return xresult.intValue();
    }

    /**
     * Call remote procedure ll_1.
     * @param params Parameter(s) to the remote procedure call.
     * @return Result from remote procedure call.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public LINKEDLIST ll_1(LINKEDLIST params)
           throws OncRpcException, IOException {
        LINKEDLIST result = new LINKEDLIST();
        client.call(demo.ll_1, params, result);
        return result;
    }

    /**
     * Call remote procedure NULL_2.
     * @param params Parameter(s) to the remote procedure call.
     * @return Result from remote procedure call.
     * @throws OncRpcException if an ONC/RPC error occurs.
     * @throws IOException if an I/O error occurs.
     */
    public void NULL_2()
           throws OncRpcException, IOException {
        XdrVoid xparams = XdrVoid.XDR_VOID;
        XdrVoid xresult = XdrVoid.XDR_VOID;
        client.call(demo.NULL_2, xparams, xresult);
    }

}
// End of demoClient.java
